import { ClassMetaNode } from './classMetaCreator';
import { MethodMetaCreator } from './methodMetaCreator';
import { ParameterMetaCreator } from './parameterMetaCreator';
import { interfaces, Container } from 'inversify';
export declare type TClassIndefiner<T> = interfaces.Newable<T> & interfaces.Abstract<T>;
export declare type TAnnotationScanerMethod = {
    meta: MethodMetaCreator;
    parameter: ParameterMetaCreator;
};
export declare type TAnnotationScanerResult = {
    meta: ClassMetaNode;
    methods: Map<string, TAnnotationScanerMethod>;
};
export declare function AnnotationMetaDataScan<T extends TClassIndefiner<X>, X = any>(classModule: T, container?: Container): TAnnotationScanerResult;
export declare function AnnotationDependenciesAutoRegister<T extends TClassIndefiner<X>, X = any>(classModule: T, container?: Container): void;
