import React, { useState, Fragment, useEffect, useReducer } from 'react';
import ReactDOM from 'react-dom';
import { METADATA_KEY, injectable, Container } from 'inversify';
export * from 'inversify';
import Url from 'url-parse';
import { effect, stop, reactive } from '@vue/reactivity';
export * from '@vue/reactivity';
import 'reflect-metadata';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spreadArray(to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
}

function Root(props) {
    var _a = __read(useState([]), 2), middlewares = _a[0], setMiddlewares = _a[1];
    var next = React.createElement(Fragment);
    var i = middlewares.length;
    while (i--) {
        next = React.createElement(middlewares[i].middleware, middlewares[i].props || {}, next);
    }
    useEffect(function () { return props.bootstrap(setMiddlewares); }, [props.bootstrap]);
    return next;
}

var UTF8_ACCEPT = 12;
var UTF8_REJECT = 0;
var UTF8_DATA = [
    // The first part of the table maps bytes to character to a transition.
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
    3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
    4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
    5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
    6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 7, 7,
    10, 9, 9, 9, 11, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
    // The second part of the table maps a state to a new state when adding a
    // transition.
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    12, 0, 0, 0, 0, 24, 36, 48, 60, 72, 84, 96,
    0, 12, 12, 12, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 24, 24, 24, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 24, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 48, 48, 48, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 48, 48, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    // The third part maps the current transition to a mask that needs to apply
    // to the byte.
    0x7F, 0x3F, 0x3F, 0x3F, 0x00, 0x1F, 0x0F, 0x0F, 0x0F, 0x07, 0x07, 0x07
];
function decodeURIComponent(uri) {
    var percentPosition = uri.indexOf('%');
    if (percentPosition === -1)
        return uri;
    var length = uri.length;
    var decoded = '';
    var last = 0;
    var codepoint = 0;
    var startOfOctets = percentPosition;
    var state = UTF8_ACCEPT;
    while (percentPosition > -1 && percentPosition < length) {
        var high = hexCodeToInt(uri[percentPosition + 1], 4);
        var low = hexCodeToInt(uri[percentPosition + 2], 0);
        var byte = high | low;
        var type = UTF8_DATA[byte];
        state = UTF8_DATA[256 + state + type];
        codepoint = (codepoint << 6) | (byte & UTF8_DATA[364 + type]);
        if (state === UTF8_ACCEPT) {
            decoded += uri.slice(last, startOfOctets);
            decoded += (codepoint <= 0xFFFF)
                ? String.fromCharCode(codepoint)
                : String.fromCharCode((0xD7C0 + (codepoint >> 10)), (0xDC00 + (codepoint & 0x3FF)));
            codepoint = 0;
            last = percentPosition + 3;
            percentPosition = startOfOctets = uri.indexOf('%', last);
        }
        else if (state === UTF8_REJECT) {
            return null;
        }
        else {
            percentPosition += 3;
            if (percentPosition < length && uri.charCodeAt(percentPosition) === 37)
                continue;
            return null;
        }
    }
    return decoded + uri.slice(last);
}
var HEX = {
    '0': 0,
    '1': 1,
    '2': 2,
    '3': 3,
    '4': 4,
    '5': 5,
    '6': 6,
    '7': 7,
    '8': 8,
    '9': 9,
    'a': 10,
    'A': 10,
    'b': 11,
    'B': 11,
    'c': 12,
    'C': 12,
    'd': 13,
    'D': 13,
    'e': 14,
    'E': 14,
    'f': 15,
    'F': 15
};
function hexCodeToInt(c, shift) {
    var i = HEX[c];
    return i === undefined ? 255 : i << shift;
}

var types;
(function (types) {
    types[types["STATIC"] = 0] = "STATIC";
    types[types["PARAM"] = 1] = "PARAM";
    types[types["MATCH_ALL"] = 2] = "MATCH_ALL";
    types[types["REGEX"] = 3] = "REGEX";
    // It's used for a parameter, that is followed by another parameter in the same part
    types[types["MULTI_PARAM"] = 4] = "MULTI_PARAM";
})(types || (types = {}));
var Handlers = buildHandlers();
var Node = /** @class */ (function () {
    function Node(options) {
        if (options === void 0) { options = {}; }
        this.prefix = options.prefix || '/';
        this.label = this.prefix[0];
        this.children = options.children || {};
        this.numberOfChildren = Object.keys(this.children).length;
        this.kind = options.kind || this.types.STATIC;
        this.handlers = new Handlers(options.handlers);
        this.regex = options.regex || null;
        this.wildcardChild = null;
        this.parametricBrother = null;
    }
    Object.defineProperty(Node.prototype, "types", {
        get: function () {
            return types;
        },
        enumerable: false,
        configurable: true
    });
    Node.prototype.getLabel = function () {
        return this.prefix[0];
    };
    Node.prototype.addChild = function (node) {
        var _this = this;
        var label = '';
        switch (node.kind) {
            case this.types.STATIC:
                label = node.getLabel();
                break;
            case this.types.PARAM:
            case this.types.REGEX:
            case this.types.MULTI_PARAM:
                label = ':';
                break;
            case this.types.MATCH_ALL:
                this.wildcardChild = node;
                label = '*';
                break;
            default: throw new Error("Unknown node kind: " + node.kind);
        }
        if (this.children[label] !== undefined) {
            throw new Error("There is already a child with label '" + label + "'");
        }
        this.children[label] = node;
        this.numberOfChildren = Object.keys(this.children).length;
        var labels = Object.keys(this.children);
        var parametricBrother = this.parametricBrother;
        for (var i = 0; i < labels.length; i++) {
            var child = this.children[labels[i]];
            if (child.label === ':') {
                parametricBrother = child;
                break;
            }
        }
        var iterate = function (node) {
            if (!node)
                return;
            if (node.kind !== _this.types.STATIC)
                return;
            if (node !== _this) {
                node.parametricBrother = parametricBrother || node.parametricBrother;
            }
            var labels = Object.keys(node.children);
            for (var i = 0; i < labels.length; i++) {
                iterate(node.children[labels[i]]);
            }
        };
        iterate(this);
        return this;
    };
    Node.prototype.reset = function (prefix) {
        this.prefix = prefix;
        this.children = {};
        this.kind = this.types.STATIC;
        this.handlers = new Handlers();
        this.numberOfChildren = 0;
        this.regex = null;
        this.wildcardChild = null;
        return this;
    };
    Node.prototype.findByLabel = function (path) {
        return this.children[path[0]];
    };
    Node.prototype.findChild = function (path) {
        var method = 'GET';
        var child = this.findByLabel(path);
        if (child !== undefined && (child.numberOfChildren > 0 || child.handlers[method] !== null)) {
            if (path.slice(0, child.prefix.length) === child.prefix)
                return child;
        }
        child = this.children[':'] || this.children['*'];
        if (child !== undefined && (child.numberOfChildren > 0 || child.handlers[method] !== null))
            return child;
        return null;
    };
    Node.prototype.setHandler = function (handler, params) {
        if (!handler)
            return;
        var method = 'GET';
        if (this.handlers[method] === undefined)
            throw new Error("There is already an handler with method '" + method + "'");
        this.handlers[method] = {
            handler: handler,
            params: params,
            paramsLength: params.length
        };
    };
    Node.prototype.getHandler = function () {
        return this.handlers['GET'];
    };
    return Node;
}());
function buildHandlers() {
    return /** @class */ (function () {
        function NodeHelper(handlers) {
            handlers = handlers || {};
            this['GET'] = handlers['GET'] || null;
        }
        return NodeHelper;
    }());
}

var NODE_TYPES = types;
var FULL_PATH_REGEXP = /^https?:\/\/.*\//;
var Router = /** @class */ (function () {
    function Router(opts) {
        if (opts === void 0) { opts = {}; }
        this.caseSensitive = opts.caseSensitive === undefined ? true : opts.caseSensitive;
        this.ignoreTrailingSlash = opts.ignoreTrailingSlash || false;
        this.maxParamLength = opts.maxParamLength || 100;
        this.tree = new Node();
        this.routes = [];
    }
    Router.prototype.on = function (path, opts, handler) {
        if (typeof opts === 'function') {
            handler = opts;
            opts = {};
        }
        if (typeof path !== 'string')
            throw new Error('Path should be a string');
        if (path.length === 0)
            throw new Error('The path could not be empty');
        if (path[0] !== '/' && path[0] !== '*')
            throw new Error('The first character of a path should be `/` or `*`');
        if (typeof handler !== 'function')
            throw new Error('Handler should be a function');
        this._on(path, opts, handler);
        if (this.ignoreTrailingSlash && path !== '/' && !path.endsWith('*')) {
            if (path.endsWith('/')) {
                this._on(path.slice(0, -1), opts, handler);
            }
            else {
                this._on(path + '/', opts, handler);
            }
        }
    };
    Router.prototype._on = function (path, opts, handler) {
        var params = [];
        var j = 0;
        this.routes.push({
            method: 'GET',
            path: path,
            opts: opts,
            handler: handler
        });
        for (var i = 0, len = path.length; i < len; i++) {
            // search for parametric or wildcard routes
            // parametric route
            if (path.charCodeAt(i) === 58) {
                var nodeType = NODE_TYPES.PARAM;
                j = i + 1;
                var staticPart = path.slice(0, i);
                if (this.caseSensitive === false) {
                    staticPart = staticPart.toLowerCase();
                }
                // add the static part of the route to the tree
                this._insert(staticPart, 0, null, null, null);
                // isolate the parameter name
                var isRegex = false;
                while (i < len && path.charCodeAt(i) !== 47) {
                    isRegex = isRegex || path[i] === '(';
                    if (isRegex) {
                        i = getClosingParenthensePosition(path, i) + 1;
                        break;
                    }
                    else if (path.charCodeAt(i) !== 45) {
                        i++;
                    }
                    else {
                        break;
                    }
                }
                if (isRegex && (i === len || path.charCodeAt(i) === 47)) {
                    nodeType = NODE_TYPES.REGEX;
                }
                else if (i < len && path.charCodeAt(i) !== 47) {
                    nodeType = NODE_TYPES.MULTI_PARAM;
                }
                var parameter = path.slice(j, i);
                var regex = isRegex ? new RegExp(parameter.slice(parameter.indexOf('('), i)) : null;
                params.push(parameter.slice(0, isRegex ? parameter.indexOf('(') : i));
                path = path.slice(0, j) + path.slice(i);
                i = j;
                len = path.length;
                // if the path is ended
                if (i === len) {
                    var completedPath = path.slice(0, i);
                    if (this.caseSensitive === false) {
                        completedPath = completedPath.toLowerCase();
                    }
                    return this._insert(completedPath, nodeType, params, handler, regex);
                }
                // add the parameter and continue with the search
                this._insert(path.slice(0, i), nodeType, params, null, regex);
                i--;
            }
            else if (path.charCodeAt(i) === 42) {
                this._insert(path.slice(0, i), 0, null, null, null);
                // add the wildcard parameter
                params.push('*');
                return this._insert(path.slice(0, len), 2, params, handler, null);
            }
        }
        if (this.caseSensitive === false) {
            path = path.toLowerCase();
        }
        // static route
        this._insert(path, 0, params, handler, null);
    };
    Router.prototype._insert = function (path, kind, params, handler, regex) {
        if (params === void 0) { params = []; }
        var route = path;
        var currentNode = this.tree;
        var prefix = '';
        var pathLen = 0;
        var prefixLen = 0;
        var len = 0;
        var max = 0;
        var node = null;
        while (true) {
            prefix = currentNode.prefix;
            prefixLen = prefix.length;
            pathLen = path.length;
            len = 0;
            // search for the longest common prefix
            max = pathLen < prefixLen ? pathLen : prefixLen;
            while (len < max && path[len] === prefix[len])
                len++;
            // the longest common prefix is smaller than the current prefix
            // let's split the node and add a new child
            if (len < prefixLen) {
                node = new Node({ prefix: prefix.slice(len),
                    children: currentNode.children,
                    kind: currentNode.kind,
                    handlers: new Handlers(currentNode.handlers),
                    regex: currentNode.regex });
                if (currentNode.wildcardChild !== null) {
                    node.wildcardChild = currentNode.wildcardChild;
                }
                // reset the parent
                currentNode
                    .reset(prefix.slice(0, len))
                    .addChild(node);
                // if the longest common prefix has the same length of the current path
                // the handler should be added to the current node, to a child otherwise
                if (len === pathLen) {
                    if (currentNode.getHandler()) {
                        throw new Error("Method '" + 'GET' + "' already declared for route '" + route + "'");
                    }
                    currentNode.setHandler(handler, params);
                    currentNode.kind = kind;
                }
                else {
                    node = new Node({
                        prefix: path.slice(len),
                        kind: kind,
                        handlers: null,
                        regex: regex
                    });
                    node.setHandler(handler, params);
                    currentNode.addChild(node);
                }
                // the longest common prefix is smaller than the path length,
                // but is higher than the prefix
            }
            else if (len < pathLen) {
                // remove the prefix
                path = path.slice(len);
                // check if there is a child with the label extracted from the new path
                node = currentNode.findByLabel(path);
                // there is a child within the given label, we must go deepen in the tree
                if (node) {
                    currentNode = node;
                    continue;
                }
                // there are not children within the given label, let's create a new one!
                node = new Node({ prefix: path, kind: kind, handlers: null, regex: regex });
                node.setHandler(handler, params);
                currentNode.addChild(node);
                // the node already exist
            }
            else if (handler) {
                if (currentNode.getHandler()) {
                    throw new Error("Method '" + 'GET' + "' already declared for route '" + route + "'");
                }
                currentNode.setHandler(handler, params);
            }
            return;
        }
    };
    Router.prototype.reset = function () {
        this.tree = new Node();
        this.routes = [];
    };
    Router.prototype.off = function (path) {
        var self = this;
        var method = 'GET';
        if (Array.isArray(method)) {
            return method.map(function (method) { return self.off(path); });
        }
        // path validation
        if (typeof path !== 'string')
            throw new Error('Path should be a string');
        if (path.length === 0)
            throw new Error('The path could not be empty');
        if (path[0] !== '/' && path[0] !== '*')
            throw new Error('The first character of a path should be `/` or `*`');
        // Rebuild tree without the specific route
        var ignoreTrailingSlash = this.ignoreTrailingSlash;
        var newRoutes = self.routes.filter(function (route) {
            if (!ignoreTrailingSlash) {
                return !(method === route.method && path === route.path);
            }
            if (path.endsWith('/')) {
                var routeMatches_1 = path === route.path || path.slice(0, -1) === route.path;
                return !(method === route.method && routeMatches_1);
            }
            var routeMatches = path === route.path || (path + '/') === route.path;
            return !(method === route.method && routeMatches);
        });
        if (ignoreTrailingSlash) {
            newRoutes = newRoutes.filter(function (route, i, ar) {
                if (route.path.endsWith('/') && i < ar.length - 1) {
                    return route.path.slice(0, -1) !== ar[i + 1].path;
                }
                else if (route.path.endsWith('/') === false && i < ar.length - 1) {
                    return (route.path + '/') !== ar[i + 1].path;
                }
                return true;
            });
        }
        self.reset();
        newRoutes.forEach(function (route) { return self.on(route.path, route.opts, route.handler); });
    };
    Router.prototype.lookup = function (pathname) {
        var handle = this.find(sanitizeUrl(pathname));
        if (handle === null)
            return;
        return handle;
    };
    Router.prototype.get = function (path, handler) {
        return this.on(path, handler);
    };
    Router.prototype.find = function (path) {
        if (path.charCodeAt(0) !== 47) { // 47 is '/'
            path = path.replace(FULL_PATH_REGEXP, '/');
        }
        var originalPath = path;
        var originalPathLength = path.length;
        if (this.caseSensitive === false) {
            path = path.toLowerCase();
        }
        var maxParamLength = this.maxParamLength;
        var currentNode = this.tree;
        var wildcardNode = null;
        var pathLenWildcard = 0;
        var decoded = null;
        var pindex = 0;
        var params = [];
        var i = 0;
        var idxInOriginalPath = 0;
        while (true) {
            var pathLen = path.length;
            var prefix = currentNode.prefix;
            var prefixLen = prefix.length;
            var len = 0;
            var previousPath = path;
            // found the route
            if (pathLen === 0 || path === prefix) {
                var handle = currentNode.handlers['GET'];
                if (handle !== null && handle !== undefined) {
                    var paramsObj = {};
                    if (handle.paramsLength > 0) {
                        var paramNames = handle.params;
                        for (i = 0; i < handle.paramsLength; i++) {
                            paramsObj[paramNames[i]] = params[i];
                        }
                    }
                    return {
                        handler: handle.handler,
                        params: paramsObj,
                    };
                }
            }
            // search for the longest common prefix
            i = pathLen < prefixLen ? pathLen : prefixLen;
            while (len < i && path.charCodeAt(len) === prefix.charCodeAt(len))
                len++;
            if (len === prefixLen) {
                path = path.slice(len);
                pathLen = path.length;
                idxInOriginalPath += len;
            }
            var node = currentNode.findChild(path);
            if (node === null) {
                node = currentNode.parametricBrother;
                if (node === null) {
                    return getWildcardNode(wildcardNode, originalPath, pathLenWildcard);
                }
                if (originalPath.indexOf('/' + previousPath) === -1) {
                    // we need to know the outstanding path so far from the originalPath since the last encountered "/" and assign it to previousPath.
                    // e.g originalPath: /aa/bbb/cc, path: bb/cc
                    // outstanding path: /bbb/cc
                    var pathDiff = originalPath.slice(0, originalPathLength - pathLen);
                    previousPath = pathDiff.slice(pathDiff.lastIndexOf('/') + 1, pathDiff.length) + path;
                }
                idxInOriginalPath = idxInOriginalPath - (previousPath.length - path.length);
                path = previousPath;
                pathLen = previousPath.length;
                len = prefixLen;
            }
            var kind = node.kind;
            // static route
            if (kind === NODE_TYPES.STATIC) {
                // if exist, save the wildcard child
                if (currentNode.wildcardChild !== null) {
                    wildcardNode = currentNode.wildcardChild;
                    pathLenWildcard = pathLen;
                }
                currentNode = node;
                continue;
            }
            if (len !== prefixLen) {
                return getWildcardNode(wildcardNode, originalPath, pathLenWildcard);
            }
            // if exist, save the wildcard child
            if (currentNode.wildcardChild !== null) {
                wildcardNode = currentNode.wildcardChild;
                pathLenWildcard = pathLen;
            }
            // parametric route
            if (kind === NODE_TYPES.PARAM) {
                currentNode = node;
                i = path.indexOf('/');
                if (i === -1)
                    i = pathLen;
                if (i > maxParamLength)
                    return null;
                decoded = decodeURIComponent(originalPath.slice(idxInOriginalPath, idxInOriginalPath + i));
                if (decoded === null)
                    return null;
                params[pindex++] = decoded;
                path = path.slice(i);
                idxInOriginalPath += i;
                continue;
            }
            // wildcard route
            if (kind === NODE_TYPES.MATCH_ALL) {
                decoded = decodeURIComponent(originalPath.slice(idxInOriginalPath));
                if (decoded === null)
                    return null;
                params[pindex] = decoded;
                currentNode = node;
                path = '';
                continue;
            }
            // parametric(regex) route
            if (kind === NODE_TYPES.REGEX) {
                currentNode = node;
                i = path.indexOf('/');
                if (i === -1)
                    i = pathLen;
                if (i > maxParamLength)
                    return null;
                decoded = decodeURIComponent(originalPath.slice(idxInOriginalPath, idxInOriginalPath + i));
                if (decoded === null)
                    return null;
                if (!node.regex.test(decoded))
                    return null;
                params[pindex++] = decoded;
                path = path.slice(i);
                idxInOriginalPath += i;
                continue;
            }
            // multiparametric route
            if (kind === NODE_TYPES.MULTI_PARAM) {
                currentNode = node;
                i = 0;
                if (node.regex !== null) {
                    var matchedParameter = path.match(node.regex);
                    if (matchedParameter === null)
                        return null;
                    i = matchedParameter[1].length;
                }
                else {
                    while (i < pathLen && path.charCodeAt(i) !== 47 && path.charCodeAt(i) !== 45)
                        i++;
                    if (i > maxParamLength)
                        return null;
                }
                decoded = decodeURIComponent(originalPath.slice(idxInOriginalPath, idxInOriginalPath + i));
                if (decoded === null)
                    return null;
                params[pindex++] = decoded;
                path = path.slice(i);
                idxInOriginalPath += i;
                continue;
            }
            wildcardNode = null;
        }
    };
    return Router;
}());
function sanitizeUrl(url) {
    for (var i = 0, len = url.length; i < len; i++) {
        var charCode = url.charCodeAt(i);
        // Some systems do not follow RFC and separate the path and query
        // string with a `;` character (code 59), e.g. `/foo;jsessionid=123456`.
        // Thus, we need to split on `;` as well as `?` and `#`.
        if (charCode === 63 || charCode === 59 || charCode === 35) {
            return url.slice(0, i);
        }
    }
    return url;
}
function getWildcardNode(node, path, len) {
    var method = 'GET';
    if (node === null)
        return null;
    var decoded = decodeURIComponent(path.slice(-len));
    if (decoded === null)
        return null;
    var handle = node.handlers[method];
    if (handle !== null && handle !== undefined) {
        return {
            handler: handle.handler,
            params: { '*': decoded },
        };
    }
    return null;
}
function getClosingParenthensePosition(path, idx) {
    // `path.indexOf()` will always return the first position of the closing parenthese,
    // but it's inefficient for grouped or wrong regexp expressions.
    // see issues #62 and #63 for more info
    var parentheses = 1;
    while (idx < path.length) {
        idx++;
        // ignore skipped chars
        if (path[idx] === '\\') {
            idx++;
            continue;
        }
        if (path[idx] === ')') {
            parentheses--;
        }
        else if (path[idx] === '(') {
            parentheses++;
        }
        if (!parentheses)
            return idx;
    }
    throw new Error('Invalid regexp expression in "' + path + '"');
}

function useReactiveState(fn) {
    var _a = __read(useReducer(function (state, action) { return action; }, fn()), 2), state = _a[0], dispatch = _a[1];
    useEffect(function () {
        var unmounted = false;
        var useSafeDispatch = function (job) {
            if (unmounted)
                return;
            if (job === undefined)
                return dispatch(fn());
            var value = job();
            if (value === undefined)
                return;
            dispatch(value);
        };
        var _effect = effect(fn, {
            lazy: true,
            scheduler: useSafeDispatch,
        });
        useSafeDispatch(_effect);
        return function () {
            unmounted = true;
            stop(_effect);
        };
    }, []);
    return state;
}

var Request = reactive({
    protocol: null,
    slashes: false,
    auth: null,
    username: null,
    password: null,
    host: null,
    hostname: null,
    port: null,
    pathname: null,
    query: new Map(),
    hash: null,
    href: null,
    origin: null,
    params: new Map(),
});
function assign(url, params) {
    if (params === void 0) { params = {}; }
    Request.protocol = url.protocol;
    Request.slashes = url.slashes;
    Request.auth = url.auth;
    Request.username = url.username;
    Request.password = url.password;
    Request.host = url.host;
    Request.hostname = url.hostname;
    Request.port = url.port;
    Request.pathname = url.pathname;
    Request.hash = url.hash;
    Request.href = url.href;
    Request.origin = url.origin;
    merge(Request.query, url.query);
    merge(Request.params, params);
    return Request;
}
function redirect(url) {
    if (url === void 0) { url = '/'; }
    switch (History.mode) {
        case 'popstate':
            window.history.pushState(null, window.document.title, url);
            History.listener();
            break;
        case 'hashchange':
            window.location.hash = url;
            break;
    }
}
function replace(url) {
    if (url === void 0) { url = '/'; }
    switch (History.mode) {
        case 'popstate':
            window.history.pushState(null, window.document.title, url);
            History.listener();
            break;
        case 'hashchange':
            window.location.hash = url;
            break;
    }
}
function useLocation(callback) {
    return useReactiveState(function () { return callback(Request); });
}
function useQuery(key, defaultValue) {
    return useLocation(function (req) { return (req.query.has(key) ? req.query.get(key) : defaultValue || null); });
}
function useParam(key, defaultValue) {
    return useLocation(function (req) { return (req.params.has(key) ? req.params.get(key) : defaultValue || null); });
}
function merge(target, data) {
    target.clear();
    for (var i in data) {
        if (Object.prototype.hasOwnProperty.call(data, i)) {
            target.set(i, data[i]);
        }
    }
}

var History = {
    mode: null,
    listener: function () { },
    notFoundComponent: function () { return null; },
};
function createHistory(router, mode, set) {
    if (mode === void 0) { mode = 'hashchange'; }
    if (mode === 'popstate') {
        if (!window.history.pushState || window.location.protocol.toLowerCase().indexOf('file:') === 0) {
            mode = 'hashchange';
        }
    }
    History.mode = mode;
    var listener = History.listener = function () {
        var url = getUrlByLocation(mode);
        var matched = router.find(url.pathname);
        if (matched) {
            assign(url, matched.params);
            matched.handler();
        }
        else {
            assign(url);
            set([{ middleware: History.notFoundComponent }]);
        }
        return function () { return window.removeEventListener(mode, listener); };
    };
    return function () {
        window.addEventListener(mode, listener);
        return listener();
    };
}
function getUrlByLocation(mode) {
    var href = new Url(window.location.href, true);
    if (mode === 'hashchange') {
        var hash = window.location.hash.replace(/^\#/, '') || '/';
        var _hash = new Url(hash, true);
        href.set('pathname', _hash.pathname);
        href.set('query', _hash.query);
        href.set('hash', _hash.hash);
    }
    return href;
}

var ClassMetaNode = /** @class */ (function () {
    function ClassMetaNode() {
        this.stacks = new Map();
    }
    ClassMetaNode.prototype.set = function (key, value) {
        this.stacks.set(key, value);
        return this;
    };
    ClassMetaNode.prototype.get = function (key) {
        return this.stacks.get(key);
    };
    Object.defineProperty(ClassMetaNode.prototype, "size", {
        get: function () {
            return this.stacks.size;
        },
        enumerable: false,
        configurable: true
    });
    ClassMetaNode.prototype.has = function (key) {
        return this.stacks.has(key);
    };
    Object.defineProperty(ClassMetaNode.prototype, "isEmpty", {
        get: function () {
            return this.size > 0;
        },
        enumerable: false,
        configurable: true
    });
    ClassMetaNode.prototype.got = function (name, defaultValue) {
        if (this.has(name))
            return this.get(name);
        return defaultValue;
    };
    return ClassMetaNode;
}());
var ClassMetaCreator = /** @class */ (function () {
    function ClassMetaCreator() {
        this.stacks = new Map();
    }
    ClassMetaCreator.instance = function (obj) {
        var meta;
        if (!Reflect.hasMetadata(ClassMetaCreator.namespace, obj)) {
            meta = new ClassMetaCreator();
            Reflect.defineMetadata(ClassMetaCreator.namespace, meta, obj);
        }
        else {
            meta = Reflect.getMetadata(ClassMetaCreator.namespace, obj);
        }
        if (!meta.stacks.has(obj)) {
            meta.stacks.set(obj, new ClassMetaNode());
        }
        return meta.stacks.get(obj);
    };
    ClassMetaCreator.define = function (key, value) {
        return function (target) {
            var meta = ClassMetaCreator.instance(target);
            meta.set(key, value);
        };
    };
    ClassMetaCreator.push = function (key) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return function (target) {
            var meta = ClassMetaCreator.instance(target);
            var data = meta.has(key) ? meta.get(key) : [];
            data.push.apply(data, __spreadArray([], __read(args)));
            meta.set(key, data);
        };
    };
    ClassMetaCreator.unshift = function (key) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return function (target) {
            var meta = ClassMetaCreator.instance(target);
            var data = meta.has(key) ? meta.get(key) : [];
            data.unshift.apply(data, __spreadArray([], __read(args)));
            meta.set(key, data);
        };
    };
    ClassMetaCreator.join = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return function (target) { return args.forEach(function (arg) { return arg(target); }); };
    };
    ClassMetaCreator.namespace = Symbol('metadata.class.namespace');
    return ClassMetaCreator;
}());

var MethodMetaCreator = /** @class */ (function () {
    function MethodMetaCreator() {
        this.stacks = new Map();
    }
    MethodMetaCreator.prototype.setParent = function (value) {
        this.parent = value;
    };
    MethodMetaCreator.prototype.set = function (key, value) {
        this.stacks.set(key, value);
        return this;
    };
    MethodMetaCreator.prototype.get = function (key) {
        return this.stacks.get(key);
    };
    Object.defineProperty(MethodMetaCreator.prototype, "size", {
        get: function () {
            return this.stacks.size;
        },
        enumerable: false,
        configurable: true
    });
    MethodMetaCreator.prototype.has = function (key) {
        return this.stacks.has(key);
    };
    Object.defineProperty(MethodMetaCreator.prototype, "isEmpty", {
        get: function () {
            return this.size > 0;
        },
        enumerable: false,
        configurable: true
    });
    MethodMetaCreator.prototype.got = function (name, defaultValue) {
        if (this.has(name))
            return this.get(name);
        return defaultValue;
    };
    MethodMetaCreator.instance = function (obj) {
        var meta;
        if (!Reflect.hasMetadata(MethodMetaCreator.namespace, obj.value)) {
            meta = new MethodMetaCreator();
            Reflect.defineMetadata(MethodMetaCreator.namespace, meta, obj.value);
        }
        else {
            meta = Reflect.getMetadata(MethodMetaCreator.namespace, obj.value);
        }
        return meta;
    };
    MethodMetaCreator.define = function (key, value) {
        return function (target, property, descriptor) {
            var meta = MethodMetaCreator.instance(descriptor);
            meta.set(key, value);
        };
    };
    MethodMetaCreator.push = function (key) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return function (target, property, descriptor) {
            var meta = MethodMetaCreator.instance(descriptor);
            var data = meta.has(key) ? meta.get(key) : [];
            data.push.apply(data, __spreadArray([], __read(args)));
            meta.set(key, data);
        };
    };
    MethodMetaCreator.unshift = function (key) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return function (target, property, descriptor) {
            var meta = MethodMetaCreator.instance(descriptor);
            var data = meta.has(key) ? meta.get(key) : [];
            data.unshift.apply(data, __spreadArray([], __read(args)));
            meta.set(key, data);
        };
    };
    MethodMetaCreator.join = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return function (target, property, descriptor) { return args.forEach(function (arg) { return arg(target, property, descriptor); }); };
    };
    MethodMetaCreator.namespace = Symbol('metadata.method.namespace');
    return MethodMetaCreator;
}());

var ParameterMetaCreator = /** @class */ (function () {
    function ParameterMetaCreator() {
        this.stacks = [];
    }
    ParameterMetaCreator.prototype.setParent = function (value) {
        this.parent = value;
    };
    Object.defineProperty(ParameterMetaCreator.prototype, "size", {
        get: function () {
            return this.stacks.length;
        },
        enumerable: false,
        configurable: true
    });
    ParameterMetaCreator.prototype.set = function (index, callback) {
        this.stacks[index] = callback;
        return this;
    };
    ParameterMetaCreator.prototype.get = function (index, ctx) {
        var _a;
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        if (typeof this.stacks[index] !== 'function')
            return;
        return (_a = this.stacks)[index].apply(_a, __spreadArray([ctx], __read(args)));
    };
    ParameterMetaCreator.prototype.exec = function (ctx) {
        return Promise.all(this.stacks.map(function (fn) {
            if (typeof fn === 'function')
                return Promise.resolve(fn(ctx));
            return Promise.resolve();
        }));
    };
    ParameterMetaCreator.instance = function (obj) {
        var meta;
        if (!Reflect.hasMetadata(ParameterMetaCreator.namespace, obj)) {
            meta = new ParameterMetaCreator();
            Reflect.defineMetadata(ParameterMetaCreator.namespace, meta, obj);
        }
        else {
            meta = Reflect.getMetadata(ParameterMetaCreator.namespace, obj);
        }
        return meta;
    };
    ParameterMetaCreator.define = function (callback) {
        return function (target, property, index) {
            var clazz = target.constructor.prototype[property];
            if (!clazz)
                return;
            var meta = ParameterMetaCreator.instance(clazz);
            meta.set(index, function (ctx) { return callback(ctx); });
        };
    };
    ParameterMetaCreator.pushToParent = function (key) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return function (target, property, index) {
            var func = Object.getOwnPropertyDescriptor(target.constructor.prototype, property);
            var meta = MethodMetaCreator.instance(func);
            var data = meta.has(key) ? meta.get(key) : [];
            data.push.apply(data, __spreadArray([], __read(args)));
            meta.set(key, data);
        };
    };
    ParameterMetaCreator.unshiftToParent = function (key) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return function (target, property, index) {
            var func = Object.getOwnPropertyDescriptor(target.constructor.prototype, property);
            var meta = MethodMetaCreator.instance(func);
            var data = meta.has(key) ? meta.get(key) : [];
            data.push.apply(data, __spreadArray([], __read(args)));
            meta.set(key, data);
        };
    };
    ParameterMetaCreator.joinToParent = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return function (target, property, index) { return args.forEach(function (arg) { return arg(target, property, index); }); };
    };
    ParameterMetaCreator.namespace = Symbol('metadata.parameter.namespace');
    return ParameterMetaCreator;
}());

function AnnotationMetaDataScan(classModule, container) {
    // Auto register parent and children.
    AnnotationDependenciesAutoRegister(classModule, container);
    var classMeta = ClassMetaCreator.instance(classModule);
    var properties = Object.getOwnPropertyNames(classModule.prototype);
    var methods = new Map();
    properties.forEach(function (property) {
        if (property === 'constructor')
            return;
        var descriptor = Object.getOwnPropertyDescriptor(classModule.prototype, property);
        if (descriptor.value && typeof descriptor.value === 'function') {
            var that = classModule.prototype[property];
            var methodMeta = MethodMetaCreator.instance(descriptor);
            var parameterMeta = ParameterMetaCreator.instance(that);
            methodMeta.setParent(classMeta);
            parameterMeta.setParent(methodMeta);
            methods.set(property, {
                meta: methodMeta,
                parameter: parameterMeta,
            });
        }
    });
    return {
        meta: classMeta,
        methods: methods,
    };
}
function AnnotationDependenciesAutoRegister(classModule, container) {
    var injectable = Reflect.hasMetadata(METADATA_KEY.PARAM_TYPES, classModule);
    if (injectable && container && !container.isBound(classModule)) {
        container.bind(classModule).toSelf().inSingletonScope();
        var propsInjectable = Reflect.hasMetadata(METADATA_KEY.TAGGED_PROP, classModule);
        if (propsInjectable) {
            var props = Reflect.getMetadata(METADATA_KEY.TAGGED_PROP, classModule);
            for (var i in props) {
                var chunk = props[i];
                if (Array.isArray(chunk)) {
                    chunk.forEach(function (model) {
                        if (model.key === 'inject' && !container.isBound(model.value)) {
                            AnnotationDependenciesAutoRegister(model.value, container);
                        }
                    });
                }
            }
        }
    }
}

function classScan(target) {
    var properties = Object.getOwnPropertyNames(target.prototype);
    properties.forEach(function (property) {
        if (property === 'constructor')
            return;
        if (typeof target.prototype[property] === 'function') {
            var descriptor = Object.getOwnPropertyDescriptor(target.prototype, property);
            var instance = MethodMetaCreator.instance(descriptor);
            if (instance.size) {
                target.prototype[property].__descriptor__ = descriptor;
            }
        }
    });
}

var placeholder = Symbol('React.FunctionComponent.Cached.Placeholder');
function Component() {
    return ClassMetaCreator.join(ClassMetaCreator.define(Component.namespace, true), injectable(), classScan);
}
function Service() {
    return ClassMetaCreator.join(ClassMetaCreator.define(Service.namespace, true), injectable(), classScan);
}
Component.namespace = Symbol('COMPONENT');
Service.namespace = Symbol('SERVICE');
var WrapNamespace = Symbol('WRAP');
function useComponentWithClass(component) {
    if (!isIocComponent(component) || !component.prototype || !component.prototype.render)
        throw new Error('component must be a IOC classify object.');
    var context = container.get(component);
    return componentBindContext(context.render, context);
}
function useComponentWithMethod(component, context) {
    return componentBindContext(component, context);
}
function useComponent(component) {
    if (!component.render)
        throw new Error('component must be a IOC classify constructor.');
    return componentBindContext(component.render, component);
}
function isIocComponent(component) {
    var isIOComponent = false;
    if (component.prototype && component.prototype.render) {
        isIOComponent = true;
    }
    return isIOComponent;
}
function componentBindContext(fn, context) {
    // @ts-ignore
    if (!fn[placeholder]) {
        // @ts-ignore
        fn[placeholder] = fn.bind(context);
        // @ts-ignore
        var descriptor = fn.__descriptor__;
        if (descriptor) {
            var instance = MethodMetaCreator.instance(descriptor);
            if (instance.has(WrapNamespace)) {
                var wraper = instance.get(WrapNamespace);
                // @ts-ignore
                fn[placeholder] = wraper(fn[placeholder]);
            }
        }
    }
    // @ts-ignore
    return fn[placeholder];
}

function Controller(url) {
    if (url === void 0) { url = '/'; }
    return ClassMetaCreator.define(Controller.namespace, url);
}
Controller.namespace = Symbol('CONTROLLER');

function Middleware(component, options) {
    var isIoc = isIocComponent(component);
    if (isIoc)
        AnnotationDependenciesAutoRegister(component, container);
    return ClassMetaCreator.unshift(Middleware.namespace, isIoc
        ? {
            middleware: isIoc
                ? useComponentWithClass(component)
                : component,
            props: options
        }
        : { middleware: component, props: options });
}
Middleware.namespace = Symbol('MIDDLEWARE');

function Memo(callback) {
    return MethodMetaCreator.define(WrapNamespace, function (fn) { return React.memo(fn, callback); });
}

function ForwardRef() {
    return MethodMetaCreator.define(WrapNamespace, function (fn) { return React.forwardRef(fn); });
}

function usePromise(fn, initialState, deps) {
    var _a = __read(useReducer(function (state, action) { return action; }, false), 2), loading = _a[0], setLoading = _a[1];
    var _b = __read(useReducer(function (state, action) { return action; }, initialState), 2), result = _b[0], setResult = _b[1];
    var _c = __read(useReducer(function (state, action) { return action; }, null), 2), error = _c[0], setError = _c[1];
    useEffect(function () {
        var cancel, unmounted = false;
        setLoading(true);
        var promise = new Promise(function (resolve, reject) { return cancel = fn(resolve, reject); });
        promise.then(function (v) {
            if (!unmounted) {
                setResult(v);
            }
        }).catch(function (e) {
            if (!unmounted) {
                setError(e);
            }
        }).finally(function () {
            if (!unmounted) {
                setLoading(false);
            }
        });
        return function () {
            unmounted = true;
            // @ts-ignore
            cancel();
        };
    }, deps);
    return [loading, result, error];
}

function importLoadersWithVite(loaders, getLoader) {
    var _this = this;
    var components = {};
    for (var key in loaders) {
        var _a = getLoader(key), namespace = _a.namespace, loader = _a.loader;
        components[namespace] = React.lazy((function (loader) {
            return function () { return __awaiter(_this, void 0, void 0, function () {
                var res, component, isioc;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, loader()];
                        case 1:
                            res = _a.sent();
                            component = res.default;
                            isioc = isIocComponent(res.default);
                            if (isioc)
                                AnnotationDependenciesAutoRegister(component, container);
                            return [2 /*return*/, {
                                    default: isioc
                                        ? useComponentWithClass(component)
                                        : component
                                }];
                    }
                });
            }); };
        })(loader));
    }
    return components;
}

var router = new Router({
    maxParamLength: Infinity,
    ignoreTrailingSlash: true,
    caseSensitive: true,
});
var container = new Container();
function createServer() {
    if (History.mode)
        throw new Error('you have already bootstrap the app!');
    var globalMiddlewares = [];
    var controllers = new Set();
    function useGlobalMiddlewares(m, p) {
        var isIoc = isIocComponent(m);
        if (isIoc) {
            AnnotationDependenciesAutoRegister(m, container);
        }
        globalMiddlewares.push({
            middleware: isIoc ? useComponentWithClass(m) : m,
            props: p
        });
    }
    var defineController = function () {
        var controls = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            controls[_i] = arguments[_i];
        }
        controls.forEach(function (control) {
            AnnotationDependenciesAutoRegister(control, container);
            controllers.add(control);
        });
    };
    var createNotFoundComponent = function (component) { return History.notFoundComponent = component; };
    var bootstrap = function (mode, el) {
        var setup = function (set) {
            buildControllers(set);
            var subscribe = createHistory(router, mode, set);
            return subscribe();
        };
        ReactDOM.render(React.createElement(Root, { bootstrap: setup }), el);
    };
    var buildControllers = function (set) {
        var cache = new Map();
        controllers.forEach(function (component) {
            var meta = AnnotationMetaDataScan(component, container);
            var controller = meta.meta.get(Controller.namespace);
            if (!controller)
                return;
            var controllerMiddlewares = meta.meta.got(Middleware.namespace, []);
            var middlewares = globalMiddlewares.concat(controllerMiddlewares).map(function (middleware) {
                if (!cache.has(middleware.middleware)) {
                    cache.set(middleware.middleware, React.memo(middleware.middleware));
                }
                var cmp = cache.get(middleware.middleware);
                return {
                    middleware: cmp,
                    props: middleware.props,
                };
            });
            middlewares.push({ middleware: useComponentWithClass(component) });
            router.on(controller, function () { return set(middlewares); });
        });
    };
    return {
        bootstrap: bootstrap,
        createNotFoundComponent: createNotFoundComponent,
        useGlobalMiddlewares: useGlobalMiddlewares,
        defineController: defineController,
    };
}

export { AnnotationDependenciesAutoRegister, AnnotationMetaDataScan, ClassMetaCreator, ClassMetaNode, Component, Controller, ForwardRef, Memo, MethodMetaCreator, Middleware, ParameterMetaCreator, Service, WrapNamespace, container, createServer, importLoadersWithVite, isIocComponent, redirect, replace, useComponent, useComponentWithClass, useComponentWithMethod, useLocation, useParam, usePromise, useQuery, useReactiveState };
