import URL from 'url-parse';
export interface TRequest {
    protocol: URL['protocol'];
    slashes: URL['slashes'];
    auth: URL['auth'];
    username: URL['username'];
    password: URL['password'];
    host: URL['host'];
    hostname: URL['hostname'];
    port: URL['port'];
    pathname: URL['pathname'];
    query: Map<string, string>;
    hash: URL['hash'];
    href: URL['href'];
    origin: URL['origin'];
    params: Map<string, string>;
}
export declare const Request: {
    protocol: URL['protocol'];
    slashes: URL['slashes'];
    auth: URL['auth'];
    username: URL['username'];
    password: URL['password'];
    host: URL['host'];
    hostname: URL['hostname'];
    port: URL['port'];
    pathname: URL['pathname'];
    query: Map<string, string>;
    hash: URL['hash'];
    href: URL['href'];
    origin: URL['origin'];
    params: Map<string, string>;
};
export declare function assign(url: URL, params?: Record<string, string>): {
    protocol: string;
    slashes: boolean;
    auth: string;
    username: string;
    password: string;
    host: string;
    hostname: string;
    port: string;
    pathname: string;
    query: Map<string, string>;
    hash: string;
    href: string;
    origin: string;
    params: Map<string, string>;
};
export declare function redirect(url?: string): void;
export declare function replace(url?: string): void;
export declare function useLocation<T>(callback: (req: TRequest) => T): T;
export declare function useQuery(key: string, defaultValue?: string): string;
export declare function useParam(key: string, defaultValue?: string): string;
