export interface RouterArguments {
    caseSensitive?: boolean;
    ignoreTrailingSlash?: boolean;
    maxParamLength?: number;
}
export declare class Router {
    private caseSensitive;
    private ignoreTrailingSlash;
    private maxParamLength;
    private tree;
    private routes;
    constructor(opts?: RouterArguments);
    on(path: string, opts: object | Function, handler?: Function): void;
    private _on;
    private _insert;
    reset(): void;
    off(path: string): any;
    lookup(pathname: string): {
        handler: Function;
        params: {
            [key: string]: string;
        };
    };
    get(path: string, handler: Function): void;
    find(path: string): {
        handler: Function;
        params: {
            [key: string]: string;
        };
    };
}
