export declare enum types {
    STATIC = 0,
    PARAM = 1,
    MATCH_ALL = 2,
    REGEX = 3,
    MULTI_PARAM = 4
}
export interface TypeHandler {
    handler: Function;
    params: string[];
    paramsLength: number;
}
interface TypeHandlerMethods {
    GET?: TypeHandler;
}
interface NodeChildren {
    [label: string]: Node;
}
interface NodeArguments {
    prefix?: string;
    children?: NodeChildren;
    kind?: number;
    handlers?: TypeHandlerMethods;
    regex?: RegExp | null;
}
export declare const Handlers: {
    new (handlers?: TypeHandlerMethods): {
        GET: TypeHandler;
    };
};
export default class Node {
    prefix: string;
    label: string;
    children: NodeChildren;
    numberOfChildren: number;
    kind: number;
    regex: RegExp | null;
    wildcardChild: Node | null;
    parametricBrother: Node | null;
    handlers: TypeHandlerMethods;
    constructor(options?: NodeArguments);
    get types(): typeof types;
    getLabel(): string;
    addChild(node: Node): Node;
    reset(prefix: string): Node;
    findByLabel(path: string): Node | undefined;
    findChild(path: string): Node | null;
    setHandler(handler: Function, params: string[]): void;
    getHandler(): TypeHandler;
}
export {};
